2004-11-15  Tom Yu  <tlyu@mit.edu>

	* ext.h: New variable "must_encrypt".

	* telnetd.8: Update for changed command-line options.

	* telnetd.c (getterminaltype): Merge Athena changes to require
	encrypted connections.

	* utility.c (ttsuck): Merge Athena changes to work around some
	client timing bugs.

2004-09-22  Tom Yu  <tlyu@mit.edu>

	* Makefile.in (telnetd): Use UTIL_LIB.

2004-03-04  Ken Raeburn  <raeburn@mit.edu>

	* configure.in: Deleted; configure this dir from parent now.
	* Makefile.in (thisconfigdir, mydir): Updated.
	(LIBS): Define from @TELNETD_LIBS@.

2003-04-23  Ken Raeburn  <raeburn@mit.edu>

	* telnetd.h: Don't declare errno.

2003-01-09  Ken Raeburn  <raeburn@mit.edu>

	* telnetd.c (main): Use socklen_t when passing address to socket
	functions.

2003-01-07  Ken Raeburn  <raeburn@mit.edu>

	* Makefile.orig: Deleted.

2002-11-15  Ezra Peisach  <epeisach@bu.edu>

	* configure.in: Test for speed_t being present.

	* sys_term.c (addarg): When reallocing memory, ensure in size of
	pointer. Use speed_t instead of int for termspeeds.

	* authenc.c, ext.h, state.c, utility.c: Unsigned/signed cleanup.

2002-08-29  Ken Raeburn  <raeburn@mit.edu>

	* Makefile.in: Revert $(S)=>/ change, for Windows support.

2002-08-23  Ken Raeburn  <raeburn@mit.edu>

	* Makefile.in: Change $(S)=>/ and $(U)=>.. globally.

2002-08-08  Jen Selby  <jenselby@mit.edu>

	* telnetd.c: Switched the valid and user descriptions under the -a
	flag

2002-03-26  Ken Raeburn  <raeburn@mit.edu>

	* telnetd.c: Include fake-addrinfo.h, not fake-addrinfo.c.
	(FAI_PREFIX): Delete.

2001-10-09  Ken Raeburn  <raeburn@mit.edu>

	* defs.h, state.c, sys_term.c, telnetd-ktd.c, telnetd.c: Make
	prototypes unconditional.

Sat Sep  8 08:24:51 2001  Ezra Peisach  <epeisach@mit.edu>

	* telnetd.c: Move include of fake-addrinfo.c to after stdlib.h so
 	that malloc prototype povided.

2001-08-30  Ken Raeburn  <raeburn@mit.edu>

	* configure.in: Check for ipv6 support.

	* ext.h: Always use prototype declarations.
	(P): Definitions deleted.

	* defs.h: Don't include socket-utils.h until after netinet/in.h.

2001-08-29  Ken Raeburn  <raeburn@mit.edu>

	* defs.h: Include socket-utils.h.
	* telnetd.c: Include fake-addrinfo.c.
	(FAI_PREFIX): Define.
	(doit): Now static, and takes sockaddr pointer rather than
	sockaddr_in pointer.  Use getnameinfo instead of gethostbyaddr to
	verify that host name was available.
	(main): Use sockaddr_storage for remote address buffer; clear
	before using.  Only do IP_TOS processing for IPv4.

	* termio-tn.c, termios-tn.c: Define dummy variables if STREAMSPTY
	isn't defined, to silence compiler complaints about empty files.

2001-08-02  Tom Yu  <tlyu@mit.edu>

	* authenc.c (net_write): Rewrite in terms of netwrite().

	* configure.in: Check for vsnprintf().

	* ext.h: New prototypes for netprintf, netprintf_urg,
	netprintf_noflush, netwrite, netputs.

	* slc.c: Fix to use new NETOBUF-handling functions.

	* state.c: Fix to use new NETOBUF-handling functions.

	* telnetd.c: Fix to use new NETOBUF-handling functions.

	* termstat.c: Fix to use new NETOBUF-handling functions.

	* utility.c: General rework to be more paranoid about
	bounds-checking of NETOBUF and NFRONTP.  Abstract away
	interactions with NETOBUF to eliminate explicit references to
	NFRONTP in many places.
	(netwrite): New function; copies a buffer to the
	NETOBUF "ring buffer", checking bounds and calling netflush() if
	needed.
	(netputs): New function; calls netwrite() with a nul-terminated
	string.
	(netprintf, netprintf_ext): New function; wrap sprintf() with
	bounds checking for use with NETOBUF.
	(netprintf_urg): New function; like netprintf() except sets neturg
	to point at last char written.
	(netprintf_noflush): New function; like netprintf() except
	silently fails if NETOBUF is full.
	(ttloop, printoption, printsub, printdata): Fix to use new
	NETOBUF-handling functions.

2001-07-23  Ezra Peisach  <epeisach@mit.edu>

	* sys_term.c (startslave): Get rid of extra argument in call to
	getptyslave().

2001-07-06  Ezra Peisach  <epeisach@mit.edu>

	* sys_term.c (addarg): Cast char to long in indexing array.

2001-07-01  Ezra Peisach  <epeisach@mit.edu>

	* state.c: Declate doclientstat() static and conditionalize
	inclusion if LINEMODE defined. 

	* sys_term.c: Declare getptyslave() and addard() static.

	* telnetd.c: Declare _gettermname() and getterminaltype() static.

	* utility.c: Declare putstr() and nextitem() static.

2001-06-22  Ezra Peisach  <epeisach@mit.edu>

	* telnetd.c (main): Change variable sin to sin4.
	(encrypt_failure): Change to not shadow global error_message.

2001-06-21  Ezra Peisach  <epeisach@mit.edu>

	* telnetd.c: Add prototypes for getent() and tgetent(). 

2001-06-21  Ezra Peisach  <epeisach@mit.edu>

	* configure.in: Test if prototypes needed for setenv and unsetenv. 

	* ext.h: Provide prototypes for unsetenv and setenv if needed.

2001-06-19  Ezra Peisach  <epeisach@mit.edu>

	* utility.c (printsub): Ensure variable set before use.

2001-06-18  Ezra Peisach  <epeisach@mit.edu>

	* utility.c (printdata): Cast argument to isprint() to int.

2001-06-07  Ezra Peisach  <epeisach@mit.edu>

	* ext.h: Remove unused prototype for start_slave() and replace
	with one for startslave().

	* state.c: Add libtlnet/encrypt.h for missing prototypes.

	* sys_term.c: Add prototype for dup_tty(). Change getptyslave()
	from int to void. Cleanup an assignment in conditional warning. 

	* telnetd.c: Include libtelnet/misc-proto.h. Declare return from
	terminaltypeok() and main() as int.

	* utility.c: Include libtelnet/auth.h and libtelnet/encrypt.h for
	prototypes.

2001-04-27  Ken Raeburn  <raeburn@mit.edu>

	* telnetd.c (valid_opts): Note that 'w' takes a parameter.
	Reported by Nico Williams, <Nicolas.Williams@ubsw.com>.
	(main): Delete options 'N', 'u', 'i' that were removed from
	valid_opts in 1999.
	(usage): Don't show -u option.  Align output columns better.

2001-01-25  Tom Yu  <tlyu@mit.edu>

	* state.c (envvarok): Disallow LC_* and NLSPATH.

2000-12-06  Ken Raeburn  <raeburn@mit.edu>

	* telnetd.c (doit): Cast pty_make_sane_hostname first argument to
	sockaddr pointer.

2000-11-01  Ezra Peisach  <epeisach@mit.edu>

        * configure.in: Use AC_CHECK_HEADER and AC_CHECK_FUNC instead of
	AC_HEADER_CHECK and AC_FUNC_CHECK.

2000-06-29  Tom Yu  <tlyu@mit.edu>

	* telnetd.c (doit): Change test for "no authentication" as per
	Jeffrey Altman's patch.

2000-06-29  Nalin Dahyabhai  <nalin@redhat.com>

	* sys_term.c (start_login, Solaris): forcefully terminate "termbuf"
	in case the "TERM" environment variable isn't.
	* telnet-ktd.c (getterminaltype): Don't overflow buffers "first" and
	"netobuf".
	(recv_ayt): Forcibly terminate buffer "netobuf".

2000-05-31  Wilfredo Sanchez  <tritan@mit.edu>

	* configure.in, defs.h: Check for existance of <memory.h>.
	[from Nathan Neulinger <nneul@umr.edu>]

2000-03-20  Ken Raeburn  <raeburn@mit.edu>
	    Jeffrey Altman  <jaltman@watsun.cc.columbia.edu>

	* state.c (telrcv): Fix off-by-one error dealing with full
	buffer.

2000-02-24  Ezra Peisach  <epeisach@mit.edu>

	* configure.in: Remove dependency on libdes425 when krb4 support
		is not compiled in.

2000-02-21  Bear Giles  <bgiles@coyotesong.com>
	    Ken Raeburn  <raeburn@mit.edu>

	* telnetd.c (doit): Provide a more useful error message than
	"authentication failed" if no authentication was even attempted.

1999-10-26  Wilfredo Sanchez  <tritan@mit.edu>

	* Makefile.in: Clean up usage of CFLAGS, CPPFLAGS, DEFS, DEFINES,
	LOCAL_INCLUDES such that one can override CFLAGS from the command
	line without losing CPP search patchs and defines. Some associated
	Makefile cleanup.

Thu Apr 15 17:02:49 1999  Theodore Y. Ts'o  <tytso@mit.edu>

	* configure.in: Fix typo in test below; fixed name of the autoconf
		cache variable which indicates if sys/streams.h exists.

1999-04-13    <tytso@rsts-11.mit.edu>

	* configure.in: Check for setupterm() in libncurses in addition to
		libcurses.  Only set STREAMSPTY if both grantpt and
		sys/streams.h exists.  (Will be needed for Linux/Redhat 6.0)

Wed Mar 31 00:05:58 1999  Tom Yu  <tlyu@mit.edu>

	* sys_term.c (getptyslave): Under AIX, ignore I_PUSH pckt
	failure.

Tue Mar 30 23:59:15 1999  Tom Yu  <tlyu@mit.edu>

	* termios-tn.c: Include termio.h under AIX due to brokenness.

Wed Feb 24 20:12:10 1999  Tom Yu  <tlyu@mit.edu>

	* telnetd.8: Resync manpage.

	* telnetd.c: Rework flags controlling hostname logging.

Mon Feb 22 18:27:38 1999  Tom Yu  <tlyu@mit.edu>

	* telnetd.8: Document hostname logging changes.

	* telnetd.c: Add options to control logging of remote hostname to
	login(1).

Wed Feb  3 22:57:52 1999  Theodore Y. Ts'o  <tytso@mit.edu>

	* state.c: Increase size of subbufer so that we don't truncate
		mongo-gram tickets from Microsoft.  [telnet/688]

1998-11-14  Theodore Ts'o  <tytso@rsts-11.mit.edu>

	* configure.in: Add check for <sys/utsname.h>.

	* utility.c (putf): Add support for %s, %m, %r, %v using
		information from the uname() system call.

1998-11-13  Theodore Ts'o  <tytso@rsts-11.mit.edu>

	* Makefile.in: Set the myfulldir and mydir variables (which are
		relative to buildtop and thisconfigdir, respectively.)

Wed Aug 12 00:17:09 1998  Matthew D Hancher  <mdh@mit.edu>

	* Makefile.in (AUTH_DEF): Undefine LOGIN_CAP_F so that telnetd
	runs login with -f rather than -F for preauthenticated login, 
	following the changes in appl/bsd/.

1998-05-26  Theodore Ts'o  <tytso@rsts-11.mit.edu>

	* sys_term.c: #include utmp.h if present, and use _PATH_WTMP and
		_PATH_UTMP if defined to determine location of the wtmp
		and utmp files.

	* configure.in: Add check for utmp.h

1998-05-06  Theodore Ts'o  <tytso@rsts-11.mit.edu>

	* telnetd.c (main): 
	* telnetd-ktd.c (main): POSIX states that getopt returns -1 when it
		is done parsing options, not EOF.

Tue Mar  3 14:26:04 1998  Theodore Ts'o  <tytso@rsts-11.mit.edu>

	* configure.in: Rename HAS_* to HAVE_* for the following tests:
 		sac.h, sys/ptyvar.h, sys/filio.h, sys/stream.h,
 		gettosbyname(), and make appropriate adjustments in the
 		rest of the .c files.  Remove tests which aren't being
 		used anymore: vhangup, utmpx.h, utmp.h, etc.

	* defs.h: Use HAVE_SYS_FILIO_H instead of FILIO_H

	* sys_term.c: Use HAVE_SAC_H and HAVE_SYS_STREAM_H instead of
		HAS_SAC and STREAMS.

	* telnetd.c, telnetd-ktd.c: Use HAVE_GETTOSBYNAME instead of
		HAS_GETTOS

	* telnetd.c: Use HAVE_SYS_PTYVAR_H instead of HAS_PTYVAR.

Mon Feb 23 22:58:22 1998  Tom Yu  <tlyu@mit.edu>

	* utility.c (ptyflush, netflush): Explicitly reset SIGCHLD handler
 	before calling cleanup(). [telnet/546]

	* telnetd.c (telnet):  Explicitly reset SIGCHLD handler before
	calling cleanup(). [telnet/546]

	* state.c (dooption): Explicitly reset SIGCHLD handler before
	calling cleanup(). [telnet/546]

Wed Feb 18 15:38:31 1998  Tom Yu  <tlyu@mit.edu>

	* Makefile.in: Remove trailing slash from thisconfigdir.  Fix up
	BUILDTOP for new conventions.

Sat Feb 14 10:35:36 1998  Ezra Peisach  <epeisach@kangaroo.mit.edu>

	* configure.in: Remove USE_ANAME.

Mon Feb  2 17:02:29 1998  Theodore Ts'o  <tytso@rsts-11.mit.edu>

	* Makefile.in: Define BUILDTOP and thisconfigdir in the Makefile

Wed Jan 28 17:21:08 1998  Dan Winship  <danw@mit.edu>

	* telnetd.c (doit): additional fix for previous terminaltype change

Tue Jan 27 18:27:16 1998  Dan Winship  <danw@mit.edu>

	* telnetd.c (getterminaltype): Null-terminate strings and avoid a
	buffer overrun.

	* ext.h: make terminaltype a char[] instead of a char * for
	telnetd.c change

	* state.c (suboption): redo handling of terminaltype

Fri Jan 23 22:13:02 1998  Theodore Ts'o  <tytso@rsts-11.mit.edu>

	* telnetd.c (telnet, get_default_IM): Instead of using a hardcoded
		IM variable, use one which is dynamically generated from
		the uname() system call.

	* ext.h: Remove definition of DEFAULT_IM, since it's no longer used.

Thu Dec  4 21:32:37 1997  Tom Yu  <tlyu@mit.edu>

	* telnetd.c (doit): Fix up slave buffer length.

Thu Oct 23 13:59:32 1997  Theodore Y. Ts'o  <tytso@mit.edu>

	* state.c (envvarok): Prohibit the passing of TERMCAP, TERMPATH,
		TERMINFO, and HOME, since they can be used to exploit a
		security hole in tgetent.

Wed Apr  9 23:46:40 1997  Tom Yu  <tlyu@mit.edu>

	* sys_term.c (start_login): Bounds check the constructed "speed"
	passed in to login.

Wed Feb 12 15:22:53 1997  Tom Yu  <tlyu@voltage-multiplier.mit.edu>

	* configure.in: Fix DES425_DEPLIB

Wed Feb  5 22:08:58 1997  Tom Yu  <tlyu@mit.edu>

	* Makefile.in:
	* configure.in: Update to new program build procedure.

Thu Nov  7 15:32:06 1996  Theodore Ts'o  <tytso@rsts-11.mit.edu>

	* telnetd.c (main): Check the error return from
 		krb5_init_context(), and print an error message if
 		necessary.

Mon Oct 14 01:55:41 1996  Sam Hartman  <hartmans@mit.edu>

	* utility.c (printsub): Patch from jhawk@bbnplannet.com to deal
 	with bug printing out authentication name. [71]
Sat Sep 21 03:38:31 1996  Sam Hartman  <hartmans@mit.edu>
(printsub): Fix encrypt promise bit option parsing [74]

	* utility.c (ttloop): Continue on eintr.

Tue Sep 10 14:10:41 1996  Tom Yu  <tlyu@mit.edu>

	* telnetd.8: remove ".so man1/header.doc"

Mon Aug 19 23:22:55 1996  Theodore Y. Ts'o  <tytso@mit.edu>

	* state.c (envvarok): Don't allow the environment variable
	 	RESOLV_HOST_CONF to be set for Linux's sake.

Thu Jun 13 17:05:17 1996  Sam Hartman  <hartmans@mit.edu>

	* telnetd.8: Remove documentation of  desupported -u options.

	* sys_term.c: Remove last fragments of PARENT_DOES_UTMP, and
 	remove dependence on utmp.h and utmpx.h

	* telnetd.c: Remove support for -u option as that type of utmp
 	mucking is below the libpty abstraction and I do not see it as
 	useful enough to export outside libpty.

Tue Jun  4 00:27:09 1996  Tom Yu  <tlyu@mit.edu>

	* configure.in: Ezra's changes to allow compiling w/o krb4

Wed May  1 21:14:45 1996  Ken Raeburn  <raeburn@cygnus.com>

	* configure.in: Fix typo in Apr 16 HP-UX change.

	Thu Apr 18 16:17:55 1996  Mark Eichin  <eichin@cygnus.com>

	* state.c (envvarok): nuke all KRB5* environment variables, not
	just the previously selected ones.

	Fri Mar 29 01:21:29 1996  Marc Horowitz  <marc@mit.edu>

	* telnetd.c (telnet -> doit): moved SIGTTOU handler before the
 	first thing which would cause the terminal driver to get upset.

	Mon Mar 25 01:05:50 1996  Ken Raeburn  <raeburn@cygnus.com>

	* sys_term.c (line): Remove initialization silliness.  The
	non-GNUC method was Just Wrong, do it the other way always.
	(Xline): Specify length, not contents.

	Wed Feb 28 22:27:46 1996  Mark Eichin  <eichin@cygnus.com>

	* termio-tn.c (readstream_termio): new file, provides isolated
	version of M_IOCTL handling for systems where termio and termios
	can't be compiled together.
	* termios-tn.c (readstream_termios): new file, provides isolated
	version of M_IOCTL handling for systems where termio and termios
	can't be compiled together.
	* telnetd.c (readstream): use readstream_termios and
	readstream_termio to handle getmsg with M_IOCTL.

Thu Apr 18 16:33:42 1996  Sam Hartman  <hartmans@mit.edu>

	* state.c (suboption): Don't accept authentication suboptions
	after authentication negotiation complete.
	(envvarok):  exclude KRB5_KTNAME and KRB5CCNAME

Tue Apr 16 12:23:02 1996  Sam Hartman  <hartmans@mit.edu>

	* configure.in : Treat HPUX as if it doesn't have streams.

	* state.c (suboption): For certain options like environment and X
 	display, require authentication and encryption to be established
 	or not established before processing the option.
	(sb_auth_complete): Fail and kill telnetd if authentication
 	negotiation is not complete.

	* ext.h: Define new global variable indicating whether encryption
 	wait has happened.

Thu Apr 11 21:44:39 1996  Richard Basch  <basch@lehman.com>

	* sys_term.c (cleanup): Call the Kerberos 5 cleanup routine, also.

Wed Mar 27 00:27:32 1996  Tom Yu  <tlyu@dragons-lair.MIT.EDU>

	* telnetd.c: remove inclusion of netdb.h; it's already in defs.h,
		and #$%&* ultrix doesn't protect it from multiple
		inclusions.

Sat Mar 23 01:33:09 1996  Sam Hartman  <hartmans@tertius.mit.edu>

	* sys_term.c: Remove utmpx stuff so libpty can do it.
	(start_login): Remove utmpx handling here as well.
	(rmut): expunged; libpty should deal.

	* configure.in : Do not use streamspty on SGIs; it really doesn't
 	work, even though all the interfaces are prsent.

	* telnetd.c: Move prototype for doit to be global instead of
        streams-specific.

	Tue Mar 19 18:43:46 1996  Ken Raeburn  <raeburn@cygnus.com>

        For environments not supporting common storage:
        * defs.h (P): Add definition here.
        (line, encrypt_output, decrypt_input): Declare here.
        * ext.h (line, encrypt_output, decrypt_input): Not here.
        (terminaltype): Declare explicitly "extern".
        * telnetd.c (auth_level, require_SecurID): Don't initialize here.

Mon Mar 18 20:29:05 1996  Theodore Y. Ts'o  <tytso@dcl>

	* Makefile.in: Added flags which turn on the encryption option.

	* telnetd.c (getterminaltype): If the authentication option which
		was negotiated requires that encryption be turned on, then
		enforce this here.

Sun Mar  3 14:43:04 1996  Mark W. Eichin  <eichin@cygnus.com>

	* configure.in: if we don't have termcap, check for curses lib.

Wed Feb 28 21:07:42 1996  Mark Eichin  <eichin@cygnus.com>

	* telnetd.c (telnet): rename HE to HEstr to avoid conflict with
	HP/UX 10.01 "Fields within IO_STATUS register" values in cpu.h.

Mon Feb 26 03:33:48 1996  Sam Hartman  <hartmans@tertius.mit.edu>

	* configure.in: Call USE_ANAME

Sun Feb 25 20:26:00 1996  Sam Hartman  <hartmans@tertius.mit.edu>

	* telnetd.c: Use MAXDNAME not MAXHOSTNAMELEN; MAXHOSTNAMELEN is
        only for gethostname() and sethostname() and has nothing to do
        with domains.

	* configure.in : Check for arpa/nameser.h for MAXDNAME

Tue Feb 13 16:23:23 1996  Ezra Peisach  <epeisach@kangaroo.mit.edu>

	* ext.h, utility.c (fatalperror, fatal): Add const to argument.

Mon Jan 15 17:35:25 1996  Sam Hartman  <hartmans@tertius.mit.edu>

	* sys_term.c: Call pty_update_utmp with PTY_TTYSLOT_USABLE flag.

Mon Nov 27 15:55:50 1995  Tom Yu  <tlyu@dragons-lair.MIT.EDU>

	* state.c: use P properly so it won't break non-ansi compilers.

Sun Nov 12 04:56:15 1995  Mark W. Eichin  <eichin@cygnus.com>

	* telnetd.8: source tmac.doc for correct parsing.

Sat Oct 21 15:37:55 1995  Sam Hartman  <hartmans@tertius.mit.edu>

	* state.c (envvarok): Also check for variables involving =.

Thu Oct 19 01:28:23 1995  Mark W. Eichin  <eichin@cygnus.com>

	* state.c (envvarok): New function, checks environment variables
	for exceptions that should not be passed to login.
	(suboption): don't do anything to propagated environment variables
	if they fail the exception test above.

Mon Oct  9 23:01:36 1995  Sam Hartman  <hartmans@tertius.mit.edu>

	* telnetd.c (getterminaltype): If ENCRYPTION defined, send do
        encryption, *not* just will encrypt. if you don't do this, then you won't encrypt the input to the server; your password prompt is encrypted, but your password isn't.

Tue Aug  8 11:26:54 1995  Sam Hartman  <hartmans@pao.mit.edu>

	* sys_term.c: Fail if the slave side dies.
	(dup_tty): Renamed from login_tty because OSF already has that function and it isn't compatible.

	(getptyslave): Fix argument to fatalperror by including com_err.h instead of casting.

Tue Aug 8 17:25:22 EDT 1995	Paul Park	(pjpark@mit.edu)
	* sys_term.c - Cast argument to fatalperror().




	* sys_term.c: Use new interface to pty_update_utmp.
	(getptyslave): Handle error return from pty_open_slave
	Close syncpipe[1] before we read from it.

Mon Aug 7 14:44:21 EDT 1995	Paul Park	(pjpark@mit.edu)
	* configure.in, sys_term.c - Use utmpx.h if present, then check for
		utmp.h.  Add logic to handle ut_tv from utmpx.h.


Mon Aug 7 13:08:39 EDT 1995	Paul Park	(pjpark@mit.edu)
	* configure.in - Add check for utmp.h.  Make check for utmpx.h define
		additional symbol to work with libpty.h.
	* sys_term.c - Fix syntax error and reinstate #ifdef LINEMODE deleted
		by last checkin.

Fri Aug  4 20:22:28 1995  Sam Hartman  <hartmans@tertius.mit.edu>

	* sys_term.c (getptyslave): Select terminal settings more likely
        to work.
	(cleanup): Pass pid to cleanup so it can killpg if necessary.

Tue Aug  1 11:28:55 1995  Sam Hartman  <hartmans@tertius.mit.edu>

	* telnetd.c (doit): Use pty_getpty.

	* Makefile.in (LOCAL_LIBRARIES): Add -lpty

	* sys_term.c (startslave): Use pty_update_utmp.  Export slave's
        pid so it's global for pty_cleanup.  Use pipe to synchronize so
        that slave is opened before parent writes.
	(cleanopen): removed in favor of pty_open_slave
	(login_tty): Don't set controlling terminal; libpty does this.  Just dup2 the terminals.
	(getpty): removed.

	(getptyslave): Use libpty.

	* telnetd-ktd.c: Use libpty.

Tue Jul 11 11:32:56 1995  Sam Hartman  <hartmans@tertius.mit.edu>

Sat Jul 29 04:40:04 1995  Tom Yu  <tlyu@dragons-lair.MIT.EDU>


	* telnetd-ktd.c (doit): Remove special casing of Convex PTY
        handling here.  There isn't enough code here for me to understand
        what to do on a Convex system, so if it breaks, it should be
        special cased in a more-appropriate manner.


	* configure.in: Don't link with -lkadm.

Fri Jul 7 15:51:03 EDT 1995	Paul Park	(pjpark@mit.edu)
	* Makefile.in - Remove explicit library handling.
	* configure.in - Add USE_{KRB4,KADM}_LIBRARY and KRB5_LIBRARIES.

Tue Jun 20 14:25:01 1995  Tom Yu  (tlyu@dragons-lair)

	* defs.h: NO_STRING_H -> HAVE_STRING_H

	* configure.in: add test for string.h

Thu Jun 15 17:43:21 EDT 1995	Paul Park	(pjpark@mit.edu)
	* Makefile.in - Change explicit library names to -l<lib> form, and
		change target link line to use $(LD) and associated flags.
		Also, remove DBMLIB, it was not used. Also, for K4, use
		KRB4_LIB and KRB4_CRYPTO_LIB, these were
                split out.
	* configure.in - Remove dbm library checks, these are no longer needed
		with the Berkeley database code.  Also, add shared library
		usage check.


Thu Jun 15 16:18:39 1995  Sam Hartman  <hartmans@tardis.MIT.EDU>

	* sys_term.c (getpty): On AIX, open /dev/ptc for master and use
        ttyname() to get slave side; much simpler and doesn't get used
        ptys.

	(cleanopen): Revoke on AIX as well.  This may cause problems on early 3.2 versions, but not revoking causes disconnected sessions to be partially connected to new telnets.  The complete fix will be to make sure telnetd cleans up when it dies.




Fri Jun  9 18:29:56 1995    <tytso@rsx-11.mit.edu>

	* configure.in: Remove standardized set of autoconf macros, which
		are now handled by CONFIG_RULES.

Wed May  3 16:50:05 1995  Mark Eichin  <eichin@cygnus.com>

	* telnetd.c: respect HAVE_SYS_TTY_H.

Mon May  1 11:33:28 1995  Ezra Peisach  <epeisach@kangaroo.mit.edu>

	* defs.h: Temporary hack for the alpha. Undefine STREAMSPTY if
		defined. This will be removed in a later release.

Fri Apr 28 18:07:34 1995  Mark Eichin  <eichin@cygnus.com>

	* Makefile.in (KLIB): put KRB4_LIB inside KLIB.

Thu Apr 27 13:57:03 1995  Mark Eichin  <eichin@cygnus.com>

	* Makefile.in (telnetd): use KRB4_LIB directly.
	* configure.in: use WITH_KRB4 as-is.

Wed Apr 25 22:53:20 1995  Chris Provenzano  (proven@mit.edu)

        * configure.in, sys_term.c, telnetd.c : Have configure check for
                sys/ptyvar.h and sac.h before .c files include it.

Sat Apr 22 00:52:01 1995  Theodore Y. Ts'o  (tytso@dcl)

	* telnetd.c (main): Don't use krb5_override_default_realm, as it
		is obsolete (non-existent).  Use krb5_set_default_realm
		instead. 

Fri Apr 21 12:47:57 1995  Mark Eichin  <eichin@cygnus.com>

	From Ian Taylor <ian@cygnus.com>.
	* telnetd.c (valid_opts): Add 'L'.  If KRB5, add -R and -t.
	(main): Handle -L.  If KRB5, handle -R and -t.
	* sys_term.c (login_program): New global variable.
	(start_login): Use login_program instead of LOGIN_PROGRAM.

Wed Mar 29 15:39:39 1995  Theodore Y. Ts'o  (tytso@dcl)

	* Makefile.in: Add dependency on libtelnet.a

Tue Mar  7 19:59:30 1995  Mark Eichin  <eichin@cygnus.com>

	* configure.in: take out ISODE_INCLUDE.

Thu Mar  2 12:30:32 1995  Theodore Y. Ts'o  <tytso@dcl>

	* Makefile.in (ISODELIB): Remove reference to $(ISODELIB).

Wed Mar  1 16:25:58 1995  Theodore Y. Ts'o  <tytso@dcl>

	* configure.in: Remove ISODE_INCLUDE and ISODE_DEFS, replace check
		for -lsocket and -lnsl with WITH_NETLIB check.

Tue Feb 28 01:50:22 1995  John Gilmore  (gnu at toad.com)

	* sys_term.c:  Avoid <krb5/...> includes.

Wed Jan 11 15:23:07 1995  Mark Eichin  <eichin@cygnus.com>

	* configure.in (K4LIB): fix quoting so $(KRB4) actually survives
	to the Makefile.

Fri Nov 18 01:23:13 1994  Mark Eichin  <eichin@cygnus.com>

	* Makefile.in (install): install telnetd manpage
	(from Ted Lemon <mellon@ipd.wellsfargo.com>).

Fri Nov 18 00:44:05 1994  Mark Eichin  <eichin@cygnus.com>

	* configure.in: use WITH_KRB4, cache cc_t in termio check, cache
	SETPGRP_TWOARG check.
	* Makefile.in (K4LIB): use @K4LIB@.
	(telnetd): use $(K4LIB). (from epeisach)

Mon Nov  7 22:16:51 1994  Theodore Y. Ts'o  (tytso@dcl)

	* configure.in: 
	  sys_term.c: Only include <sys/tty.h> if HAVE_SYS_TTY_H is
	  	  defined by configure.

        * configure.in: Check for sys/time.h and time.h.

	* defs.h: Pull in <sys/time.h> and <time.h> as necessary.

	* sys_term.c (startslave): Don't define time() manually.

	* configure.in: Add check for util library (needed for the Alpha)

Thu Sep 29 22:51:52 1994  Theodore Y. Ts'o  (tytso@dcl)

	* Makefile.in: Relink executables if libraries change

Tue Aug 16 18:04:58 1994  Mark Eichin  (eichin@tweedledumber.cygnus.com)

	* configure.in: check for vhangup.
	sys_term.c (cleanup): check for HAVE_VHANGUP.
	(cleanopen): ditto.

Mon Aug  8 01:15:27 1994  Mark Eichin  (eichin@cygnus.com)

	* utility.c (putf): don't misdeclare index/rindex, strings.h
	already got included. Don't even use them -- use str*chr instead.

Thu Aug  4 03:37:26 1994  Tom Yu  (tlyu@dragons-lair)

	* configure.in: pick up dbm libs

	* sys_term.h: fix linux lossage, i.e. <linux/tty.h>
	* configure.in: check for STREAMSPTY (hopefully)

	* Makefile.in:
	* configure.in: make install changes

Tue Jul 26 18:23:01 1994  Tom Yu  (tlyu@dragons-lair)

	* Makefile.in: fix missing $(srcdir)

Mon Jul 25 02:35:16 1994  Tom Yu  (tlyu@dragons-lair)

	* configure.in: check for utmpx

